import os.path

from django.db import models
from django.contrib.auth.models import User

from .validators import validate_file_extension_and_size
from django.conf import settings


class AudioFile(models.Model):
    name = models.CharField(max_length=100)
    # owner = models.ForeignKey(User, on_delete=models.SET_NULL, null=True)
    file = models.FileField(upload_to='documents/%Y/%m/%d/', validators=[validate_file_extension_and_size])
    created = models.DateTimeField(auto_now_add=True)
    userNum = models.IntegerField(default=-1)
    trans = models.CharField(max_length=1000, default="no transcription yet")

    class Meta:
        ordering = ['-created']

    def __str__(self):
        return self.name

    def filename(self):
        return os.path.basename(self.file.name)

    def get_path(self):
        return os.path.join(settings.MEDIA_ROOT, self.file.name)

    def set_trans(self, string):
        self.trans = string

    def set_userNum(self, label_list):
        self.userNum = int(label_list[-1])
